using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {      
	CategoryBuilder.Create(" COD 4 SAS", "", ModAPI.LoadSprite("category icon.png"));       




///////////////////////////////////////////////////////////////////////////////////////

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] M4A1 Variant 1",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6a",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4v1icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		        var M4Slide = Instance.transform.Find("Slide");
                        M4Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4slide.png", 15f);
                        M4Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        M4Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HK = new GameObject("M4");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/m4v1.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4v1.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.180f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.11f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4a1sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage = 3f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] M4A1 Variant 2",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6b",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4v2icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		        var M4Slide = Instance.transform.Find("Slide");
                        M4Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4slide.png", 15f);
                        M4Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        M4Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HK = new GameObject("M4");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/m4v2.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4v2.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.180f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.11f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4a1sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage = 3f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] M4A1 Variant 3",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6c",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4v3icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		        var M4Slide = Instance.transform.Find("Slide");
                        M4Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4slide.png", 15f);
                        M4Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        M4Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HK = new GameObject("M4");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/m4v3.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4v3.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.180f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.11f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4a1sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage = 3f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] M4A1 Variant 4",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6d",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4v4icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		        var M4Slide = Instance.transform.Find("Slide");
                        M4Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4slide.png", 15f);
                        M4Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        M4Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HK = new GameObject("M4");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/m4v4.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4v4.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.180f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.11f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4a1sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage = 3f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] M4A1 Variant 5",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6e",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4v5icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		        var M4Slide = Instance.transform.Find("Slide");
                        M4Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4slide.png", 15f);
                        M4Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        M4Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HK = new GameObject("M4");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/m4v5.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4v5.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.180f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.11f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4a1sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage = 3f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] M4A1 Variant 6",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6f",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4v6icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		        var M4Slide = Instance.transform.Find("Slide");
                        M4Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4slide.png", 15f);
                        M4Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        M4Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HK = new GameObject("M4");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/m4v6.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4v6.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.180f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.11f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4a1sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage = 3f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

///////////////////////////////////////////////////////////////////////////////////////
 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] G36C",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6g",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/g36cicon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		        var G36CSlide = Instance.transform.Find("Slide");
                        G36CSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/g36cslide.png", 15f);
                        G36CSlide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        G36CSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HK = new GameObject("G36C");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/g36c.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/g36c.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.330f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.12f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/g36csound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage = 3f;
                        customCartridge.Recoil *= 6f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] W1200",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6h",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/w1200icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		        var G36CSlide = Instance.transform.Find("Slide");
                        G36CSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/w1200slide.png", 15f);
                        G36CSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/w1200.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var W1200 = new GameObject("Winchester 1200");
                        W1200.transform.SetParent(Instance.transform);
                        W1200.transform.localPosition = new Vector2(0f, 0f);
                        W1200.transform.localScale = new Vector3(1f, 1f);
                        W1200.transform.rotation = Instance.transform.rotation;
                        var W1200Sprite = W1200.AddComponent<SpriteRenderer>();
                        W1200Sprite.sprite = ModAPI.LoadSprite("weapon/w1200top.png", 15f);
                        W1200Sprite.sortingLayerName = "Foreground";

                        var W1200BACK = new GameObject("Winchester 1200 Back");
                        W1200BACK.transform.SetParent(Instance.transform);
                        W1200BACK.transform.localPosition = new Vector2(0f, 0f);
                        W1200BACK.transform.localScale = new Vector3(1f, 1f);
                        W1200BACK.transform.rotation = Instance.transform.rotation;
                        var W1200BACKSprite = W1200BACK.AddComponent<SpriteRenderer>();
                        W1200BACKSprite.sprite = ModAPI.LoadSprite("weapon/w1200back.png", 15f);
                        W1200BACKSprite.sortingLayerName = "Bottom";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.230f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 4;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/w1200sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "12-gauge";
                        customCartridge.Damage = 8f;
                        customCartridge.Recoil *= 6f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] M21",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6i",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m21icon.png"),
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m21.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m21sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 7f;
                        customCartridge.Recoil *= 8f;
                        customCartridge.ImpactForce *= 2f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = " [SAS] MP5",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6j",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/mp5icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		        var G36CSlide = Instance.transform.Find("Slide");
                        G36CSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/mp5slide.png", 15f);
                        G36CSlide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        G36CSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HK = new GameObject("MP5");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/mp5.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/mp5.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.330f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.08f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/mp5sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 2f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "[SAS] USP .45",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "6k",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/uspicon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();
						
		       var GlockSlide = Instance.transform.Find("Slide");
                       GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/uspslide.png", 20f);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/usp.png", 20f);

                        var USPBack = new GameObject("USP");
                        USPBack.transform.SetParent(Instance.transform);
                        USPBack.transform.localPosition = new Vector2(0f, 0f);
                        USPBack.transform.localScale = new Vector3(1f, 1f);
                        USPBack.transform.rotation = Instance.transform.rotation;
                        var USPBackSprite = USPBack.AddComponent<SpriteRenderer>();
                        USPBackSprite.sprite = ModAPI.LoadSprite("weapon/uspback.png", 20f);
                        USPBackSprite.sortingLayerName = "Bottom";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.06f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(-0.1f,0.06f); 
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
  
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/uspsound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 2f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 0.2f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

//////////////////////////////////////////////////////////////////////////////////////////////////////////

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = " [SAS] Vest Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3a",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest1.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest1.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest1v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = " [SAS] Vest Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3b",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = " [SAS] Vest Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3c",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest2-2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest2-2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

/////////////////////////////////////////////////////

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Hood Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3d",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hoodicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/hood.png", 12f);
 
                        int PartCount = 1;

                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);  

                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/hood.png", 12f);
                        prop.armorPoints = 1;
                        prop.offset = offset;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );


ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = " [SAS] Hood Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3e",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hood2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/hood2.png", 12f); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/hood2.png", 12f);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 1;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/hood2v2.png", 12f);
                        armProp[0].armorPiece = "Head";
                        armProp[0].offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 1;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

////////////////////////////////////////////////////////////////////////////////////////////

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = " [SAS] Helmet Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2a",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 12f);
                        prop.armorPoints = 120;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = " [SAS] Helmet Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2b",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 12f);
                        prop.armorPoints = 120;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = " [SAS] Helmet Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2c",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 12f);
                        prop.armorPoints = 120;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Gas Mask Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2d",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/gasmaskv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/gasmaskv1.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/gasmaskv1.png", 12f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Gas Mask Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/gasmaskv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/gasmaskv2.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/gasmaskv2.png", 12f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Gas Mask Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2f",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/gasmaskv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/hood2.png", 12f); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/hood2.png", 12f);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 10;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Helmet/gasmaskv3.png", 12f);
                        armProp[0].armorPiece = "Head";
                        armProp[0].offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armProp[0].armorTier = 10;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Beanie", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2g",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beanieicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/beanie.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/beanie.png", 12f);
                        prop.armorPoints = 2;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Cap", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2h",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/capicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/cap.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/cap.png", 12f);
                        prop.armorPoints = 1;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Boonie", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2i",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/boonieicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/boonie.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/boonie.png", 12f);
                        prop.armorPoints = 5;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Balaclava Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2j",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/balaclavav1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/balaclava.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/balaclava.png", 12f);
                        prop.armorPoints = 1;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Balaclava Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2k",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/balaclavav2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/hood2.png", 12f); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/hood2.png", 12f);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 3;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Helmet/balaclavav2.png", 12f);
                        armProp[0].armorPiece = "Head";
                        armProp[0].offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 3;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Price Hair", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2l",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/priceicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/price.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/price.png", 12f);
                        prop.armorPoints = 1;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Gaz Hair", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2l",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/gazicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/gaz.png", 12f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/gaz.png", 12f);
                        prop.armorPoints = 1;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

////////////////////////////////////////////////////////////////////////

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = " [SAS] Patch [Special Air Service]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4a",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch1.png", 20f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch1.png", 20f);
                        prop.armorPoints = 10;
                        prop.offset = scaleOffset;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = " [SAS] Patch [UK Flag]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4b",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch2.png", 20f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch2.png", 20f);
                        prop.armorPoints = 10;
                        prop.offset = scaleOffset;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

/////////////////////////////////////////////////////////////

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = " [SAS] Variant 1",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1a",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v1icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1.png"),
                        };
                    }
                }
            );  
  
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = " [SAS] Variant 2",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1b",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 2.png"),
                        };
                    }
                }
            );    

//////////////////////////////////////////////////////////////////////////////////////////

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Kneepad", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3t",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/kneepadicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/kneepad.png", 15f); 

                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperLegFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/kneepad2.png", 15f);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 50;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/kneepad2.png", 15f);
                        armProp[0].armorPiece = "UpperLeg";
                        armProp[0].offset = scaleOffset;
                        armProp[0].armorTier = 10;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 50;

                        armProp[1].sprite = ModAPI.LoadSprite("Armor/kneepad.png", 15f);
                        armProp[1].armorPiece = "LowerLegFront";
                        armProp[1].offset = scaleOffset;
                        armProp[1].armorTier = 10;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 50;

                        armProp[2].sprite = ModAPI.LoadSprite("Armor/kneepad.png", 15f);
                        armProp[2].armorPiece = "LowerLeg";
                        armProp[2].offset = scaleOffset;
                        armProp[2].armorTier = 10;
                        armProp[2].scaleOffset = scaleOffset;
                        armProp[2].armorPoints = 50;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = " [SAS] Elbow Pad", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3u",
                    CategoryOverride = ModAPI.FindCategory(" COD 4 SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/elbowicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/elbow2.png", 20f); 

                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/elbow2.png", 20f);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 50;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/elbow2.png", 20f);
                        armProp[0].armorPiece = "UpperArm";
                        armProp[0].offset = scaleOffset;
                        armProp[0].armorTier = 10;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 50;

                        armProp[1].sprite = ModAPI.LoadSprite("Armor/elbow.png", 20f);
                        armProp[1].armorPiece = "LowerArmFront";
                        armProp[1].offset = scaleOffset;
                        armProp[1].armorTier = 10;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 50;

                        armProp[2].sprite = ModAPI.LoadSprite("Armor/elbow.png", 20f);
                        armProp[2].armorPiece = "LowerArm";
                        armProp[2].offset = scaleOffset;
                        armProp[2].armorTier = 10;
                        armProp[2].scaleOffset = scaleOffset;
                        armProp[2].armorPoints = 50;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );








        }












public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}
